/* 
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gst/gst.h>
#include <gst/video/gstvideofilter.h>

#ifndef __BGREMOVE_H__
#define __BGREMOVE_H__

G_BEGIN_DECLS

#define GST_TYPE_BGREMOVE (bgremove_get_type())
#define GST_BGREMOVE(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_BGREMOVE,GstBgRemove))
#define GST_BGREMOVE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_BGREMOVE,GstBgRemoveClass))
#define GST_IS_BGREMOVE(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_BGREMOVE))
#define GST_IS_BGREMOVE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_BGREMOVE))

typedef struct _GstBgRemove GstBgRemove;
typedef struct _GstBgRemoveClass GstBgRemoveClass;

struct _GstBgRemove
{
  GstVideoFilter videofilter;

  gint width;
  gint height;

  GstBuffer *bg;
  guint buffer_num;

  guint8 last_target[4];

  gfloat angle;
  gfloat noise_level;

  gfloat y;                     /* chroma color */
  gint8 cb, cr;
  gint8 kg;
  gfloat accept_angle_cos;
  gfloat accept_angle_sin;
  guint8 accept_angle_tg;
  guint8 accept_angle_ctg;
  guint8 one_over_kc;
  guint8 kfgy_scale;
};

struct _GstBgRemoveClass
{
  GstVideoFilterClass parent_class;
};


GType bgremove_get_type (void);

G_END_DECLS

#endif
